package de.jottyfan.timetrack.spring.done;

import java.util.List;

import javax.annotation.security.RolesAllowed;
import javax.servlet.http.HttpServletRequest;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**
 * 
 * @author henkej
 *
 */
@Controller
public class DoneController {
	private static final Logger LOGGER = LogManager.getLogger(DoneController.class);

	private final HttpServletRequest request;

	@Autowired
	private IDoneService doneService;

	@Autowired
	public DoneController(HttpServletRequest request) {
		this.request = request;
	}

	@RolesAllowed("timetrack_user")
	@RequestMapping(value = "/done/list")
	public String getList(Model model) {
		List<DoneBean> list = doneService.getList();
		model.addAttribute("doneList", list);
		return "done/list";
	}

	@RolesAllowed("timetrack_user")
	@RequestMapping(value = "/done/add", method = RequestMethod.GET)
	public String toAdd(Model model) {
		return toItem(null, model);
	}

	@RolesAllowed("timetrack_user")
  @GetMapping("/done/edit/{id}")
	public String toItem(@PathVariable Integer id, Model model) {
		DoneBean bean = doneService.getBean(id);
		if (bean == null) {
			bean = new DoneBean(); // the add case
		}
		model.addAttribute("doneBean", bean);
//		model.addAttribute("types", Arrays.asList(EnumNotetype.values()));
//		model.addAttribute("categories", Arrays.asList(EnumCategory.values()));
		return "done/item";
	}
}
